/***************************************************************
*             Copyright (C) 2003 by SerComm Corp.
*                    All Rights Reserved.
*
*      Use of this software is restricted to the terms and
*      conditions of SerComm's software license agreement.
*
*                        www.sercomm.com
****************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "ntp.h"
#include "../cgi/inc/SYS_log.h"

#ifndef _LINKSYS_
static int GetServer(char *server){
	FILE *fd;
	int ret;

	fd = fopen("/etc/system.conf","rt");
	if(fd==NULL){
		return -1;
        }

	ret = NPRO_GetStr("system", "ntp_server", server, 50,fd);	
	if (ret != 0) {
		fclose(fd);
		return -1;
	}

	fclose(fd);

	return 0;
}
#endif

static int AddDayLightSaving(void){
        time_t now;
	FILE *fd;
	int ret,day_save;

	fd = fopen("/etc/system.conf","rt");
	if(fd==NULL){
		return -1;
        }

	ret = NPRO_GetInt("system", "day_saving", &day_save,fd);	
	if (ret != 0) {
		fclose(fd);
		return -1;
	}

	fclose(fd);

	time(&now);

	if(day_save){
		now+=3600;
	}	
	else{
		now-=3600;
	}

	/* Set new time */
	if (stime(&now) < 0) {
		return -1;
	}
	SETRTCTIME();
	return 0;
}	

int main(int argc,char *argv[]){

#ifndef _LINKSYS_
	struct hostent *h;
#endif
	char addr[16];
	int ret,DayLflag=0;
 	char server[50];

	memset(server,0,sizeof(server));
	if(argc == 1) {

#ifndef _LINKSYS_
	     GetServer(server);
#endif
	} else if(argc == 2){
	     if(!strcmp(argv[1],"-d")){
		     DayLflag=1;

#ifndef _LINKSYS_
		     GetServer(server);
#endif
	     } else {

#ifndef _LINKSYS_
		 strcpy(server,argv[1]);
#endif
	     }		     
	} else	{
		exit(1);	
	}	

#ifndef _LINKSYS_
	if(!(h=gethostbyname(server))){
	    AddLog("NTP",SYSLOG_WARNING,4);
	     exit(1);
	}
	strcpy(addr,inet_ntoa(*((struct in_addr*)h->h_addr)));

#endif

	ret=NTP_update(addr);

	if ( (ret != 0) && (DayLflag == 1) ){
		AddDayLightSaving();	
	}

	return ret;
}
