/***************************************************************
*             Copyright (C) 2003 by SerComm Corp.
*                    All Rights Reserved.
*
*      Use of this software is restricted to the terms and
*      conditions of SerComm's software license agreement.
*
*                        www.sercomm.com
****************************************************************/
#ifndef _SMTPC_H_
#define	_SMTPC_H_

#define VERSION		0x01

#define	MAX_USER	10		//max number of mail recipients		

#define	SERVER_LEN	80		
#define	TO_LEN		320		//notice: over 1 recipient		
#define	FROM_LEN	80		
#define	SUBJ_LEN	80
#define	FILE_LEN	80				

#ifdef SMTP_AUTH
#define USER_LEN	80
#define PW_LEN		80
#endif

#define SMTP_SOCKET_PATH	"/mnt/ramdisk/root/smtp_client"

//SMTPC status
#define	STC_ENABLED		1
#define STC_DISABLED		0	

//command result
#define	OK		0		
#define	INVALID_CMD	1	
#define	INVALID_DATA	2	
#define	SAVE_ERR	3		//configuration error	
#define	INVALID_VER	4	
#define	SERVER_NO_RSP	5	
#define	SEND_ERR	6	
#define	INVALID_CONN	7		// i > MAX_CONN or MAX_CONN < 0
#define NO_EN_SMTPC	8

#ifndef MY_DATA_TYPE
#define MY_DATA_TYPE
typedef unsigned char BYTE;
typedef unsigned short  WORD;   // 2 bytes
typedef unsigned int    DWORD;  // 4 bytes
typedef double          QWORD;  // 8 bytes
typedef long            LONG;   // 4 bytes
#endif

// input file format
#define FMT_TEXT	0	//US-ASCII
#define FMT_TIFF	1
#define FMT_JPEG	2
#define	FMT_GIF		3
#define FMT_MPEG	4
#define FMT_TEXT1	5	//ISO-8859-1
#define FMT_ASF		6


//head of command packet
typedef struct{
	BYTE	ver[2];
	BYTE	cmd[2];
	BYTE	result[2];
	BYTE	len[2];
}CMD_HEAD;

//config of command packet
typedef struct{
	CMD_HEAD	head;
	char		to[TO_LEN];
	char		from[FROM_LEN];
	char		subject[SUBJ_LEN];
#ifdef SMTP_AUTH
	char		server[SERVER_LEN];
	char 		auth_user[USER_LEN];
	char		auth_pw[PW_LEN];
	int		smtp_auth;
#endif
}CMD_CONF;

typedef struct{
	CMD_HEAD	head;
	BYTE		stat;			//SMTPC status
	BYTE		conn_num;		//connecting number
}CMD_STATUS;

typedef struct{
	CMD_HEAD	head;
	BYTE 		fno;			//total number of input files
	BYTE		index;			//file index
	BYTE		format;			//file format
	BYTE		last;			//1=last buffer of this file
						//0=not last buffer of this file
	BYTE		size[4];		//size of shared buffer
	BYTE		buf_id[4];			//shared buffer id
	char		ifn[FILE_LEN];			//input file names
}CMD_SENDMAIL;

typedef struct{
	CMD_HEAD	head;
	int		enable;			//1:enable  0:disable
}CMD_ENSMTPC;

#endif
