/***************************************************************
*             Copyright (C) 2003 by SerComm Corp.
*                    All Rights Reserved.
*
*      Use of this software is restricted to the terms and
*      conditions of SerComm's software license agreement.
*
*                        www.sercomm.com
****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <errno.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <syslog.h>
#include <netdb.h>
#include <string.h>
#include <ctype.h>
#include <pwd.h>

#include "smtpc.h"		
#ifndef SMTP_AUTH    
#include "smtpc_dns.h"		
#endif

static  int 	verbose    = 1;			//sam change to 1
static  int   	usesyslog  = 0;
static  char 	*from_addr  = NULL;
//char	mailhost[64];
char	mailhost[SERVER_LEN];
static  int   	mailport   = 25;
static	char	*to_addr[MAX_USER];

static  int   	chk_ehlo   = 0;			//check ehlo response
						// 1: with auth mechanism
						// 0: no auth mechanism
int s;
int r;

FILE *sfp;
static FILE *rfp;
#define dprintf  if (verbose) printf
#define dvprintf if (verbose) vprintf

#ifdef _MY_DEBUG_
#define DBG(x)	x
static char logmsg[128];
static void ClrLog(void)
{
	FILE *fh;
	fh=fopen("/tmp/smtp-1.log","w");
	if(fh)
		fclose(fh);
}
static void LogMsg(char *s)
{
	FILE *fh;
	fh=fopen("/tmp/smtp-1.log","a+");
	if(fh){
		fputs(s,fh);
		fclose(fh);
 	}
}
#else
#define DBG(x)
#endif


/*
**  logging support
*/
void log(char *str, ...)
{
    va_list ap;
    char buf[1024];

    va_start(ap, str);
    vsprintf(buf, str, ap);
    if (usesyslog)
        syslog(LOG_ERR, "SMTPclient: %s", buf);
    else
        fprintf(stderr, "SMTPclient: %s\n", buf);
    va_end(ap);
    return;
}

/*
**  examine message from server 
*/
int get_response1(void)
{
    char buf[BUFSIZ];

    memset(buf, 0, BUFSIZ);    

    while (fgets(buf, sizeof(buf), rfp)) {
        buf[strlen(buf)-1] = 0;
	if( buf[0] != '2'){
            log("unexpected reply: %s", buf);
	    return -1;
	}		
	else
            dprintf("%s --> %s\n", mailhost, buf);

        if (buf[3] != '-')
            break;
    }
    if(buf[0]==0)
	return -1;
    else
        return 0;
}

//void get_response(void)
int get_response(void)
{
    char buf[BUFSIZ];

    memset(buf, 0, BUFSIZ);    
    
    while (fgets(buf, sizeof(buf), rfp)) {
        buf[strlen(buf)-1] = 0;
        dprintf("%s --> %s\n", mailhost, buf);
        if (!isdigit((int)buf[0]) || buf[0] > '3') {
            log("unexpected reply: %s", buf);
	    return -1;
        }
	if (!(strncmp(&buf[4],"AUTH", 4)))
	    chk_ehlo=1;
        if (buf[3] != '-')
            break;
    }
    return 0;
}

/*
**  say something to server and check the response
*/
//void chat(char *fmt, ...)
int chat(char *fmt, ...)
{
    va_list ap;

    va_start(ap, fmt);
    vfprintf(sfp, fmt, ap);
    va_end(ap);
  
    va_start(ap, fmt);
    dprintf("%s <-- ", mailhost);
    dvprintf(fmt, ap);
    va_end(ap);

    fflush(sfp);
    return( get_response() );
}

int parse_to_addr(char *addr)
{
	int	i=0;
	char	tokensep[]=" ,";
	char	*token;

	token = strtok(addr, tokensep);
	to_addr[0] = (char *)malloc(strlen(token)*sizeof(char));
	strcpy(to_addr[0],token);
	while(1)
	{
		i++;
		token = strtok(NULL, tokensep);
		if(token == NULL)
			break;
		to_addr[i] = (char *)malloc(sizeof(token));
		strcpy(to_addr[i],token);
	}
	return i;
}

#ifdef SMTP_AUTH
#ifdef AUTH_TEST
char *def_server="smtp.gigigaga.com";
char *def_smtp_user="elapse";
char *def_smtp_pw="F123580392";
#endif


static char table64[]=
  "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
void base64Encode(char *intext, char *output)
{
  unsigned char ibuf[3];
  unsigned char obuf[4];
  int i;
  int inputparts;

  while(*intext) {
    for (i = inputparts = 0; i < 3; i++) { 
      if(*intext) {
        inputparts++;
        ibuf[i] = *intext;
        intext++;
      }
      else
        ibuf[i] = 0;
    }

    obuf [0] = (ibuf [0] & 0xFC) >> 2;
    obuf [1] = ((ibuf [0] & 0x03) << 4) | ((ibuf [1] & 0xF0) >> 4);
    obuf [2] = ((ibuf [1] & 0x0F) << 2) | ((ibuf [2] & 0xC0) >> 6);
    obuf [3] = ibuf [2] & 0x3F;

    switch(inputparts) {
      case 1: /* only one byte read */
        sprintf(output, "%c%c==", 
            table64[obuf[0]],
            table64[obuf[1]]);
        break;
      case 2: /* two bytes read */
        sprintf(output, "%c%c%c=", 
            table64[obuf[0]],
            table64[obuf[1]],
            table64[obuf[2]]);
        break;
      default:
        sprintf(output, "%c%c%c%c", 
            table64[obuf[0]],
            table64[obuf[1]],
            table64[obuf[2]],
            table64[obuf[3]] );
        break;
    }
    output += 4;
  }
  *output=0;
}
#endif








int Connect2SMTP(CMD_CONF *conf)
{
    char buf[BUFSIZ];
    char my_name[BUFSIZ];
    struct sockaddr_in sin;
    struct hostent *hp;
    int i,to_num;
    struct passwd *pwd;
 
    int j=0,ret,num;

    int retCode=-1;
#ifdef SMTP_AUTH
    char enc_user[128];
    char enc_pw[128];
#else
    char *p;
    struct MX *host;
#endif
 
     /* 
     *  Go away when something gets stuck.
     */
//    alarm(300);
	
        from_addr = conf->from;
	to_num = parse_to_addr(conf->to);
#ifdef AUTH_TEST
	memcpy(mailhost, def_server, SERVER_LEN);	//sam test
#else
	memcpy(mailhost, conf->server, SERVER_LEN);	
#endif
	chk_ehlo=0;
	
	DBG(ClrLog();)
	DBG(LogMsg("from config file\n");)
	DBG(sprintf(logmsg,"to:%s, from:%s, server:%s, smtp_auth%d, user:%s, pw:%s \n",conf->to,conf->from,conf->server,conf->smtp_auth,conf->auth_user,conf->auth_pw);)
	DBG(LogMsg(logmsg);)
	
#if 0
    /*
     *  Determine SMTP server
     */
    if (mailhost == NULL) {
        if ((cp = getenv("SMTPSERVER")) != NULL)
            mailhost = cp;
        else
            mailhost = "localhost";
    }
#endif


    /*
     *  Find out my own host name for HELO; 
     *  if possible, get the FQDN.
     */
    if (gethostname(my_name, sizeof(my_name) - 1) < 0) {
        log("gethostname: %s", strerror(errno));
	retCode = 1;
	goto end;
    }

#if 0
    if ((hp = gethostbyname(my_name)) == NULL) {
        log("%s: unknown host\n", my_name);
	return 1;
    }
    strcpy(my_name, hp->h_name);
#endif

    /*
     *  Determine from address.
     */
    if (from_addr == NULL) {
        if ((pwd = getpwuid(getuid())) == 0) {
            sprintf(buf, "userid-%d@%s", getuid(), my_name);
        } else {
            sprintf(buf, "%s@%s", pwd->pw_name, my_name);
        }
        from_addr = strdup(buf);
    }

    /*
     *  Connect to smtp daemon on mailhost.
     */
    DBG(LogMsg("ready connect to mailhost\n");)
		
		
    for (j = 0; j < to_num; j++) {
#ifndef SMTP_AUTH    
        p = strchr (to_addr[j], '@');
        if (!p)
            continue;
        else
            sprintf (mailhost, "%s", p + 1);
        ret = dns_mxip (mailhost, &host, &num);
        if (ret)
            continue;
	
	DBG(sprintf(logmsg,"mailhost num=%d by dns_mxip()\n",num);)
	DBG(LogMsg(logmsg);)
#else
	num=1;
#endif	
	for (i = 0; i < num; i++) {
		
	    DBG(sprintf(logmsg,"try mailhost num=%d \n",i);)
	    DBG(LogMsg(logmsg);)
	    
#ifndef SMTP_AUTH    
            if ((hp = gethostbyname (host[i].name)) == NULL) {
                if (i != num - 1) 
                    continue;
                else{
                    log ("%s: unknown host\n", mailhost);
		    retCode = 1;
		    goto end;
		}
            }
#else
    	    if ((hp = gethostbyname(mailhost)) == NULL) {
        	log("%s: unknown host\n", mailhost);
        	return -1;
    	    }
#endif
            if (hp->h_addrtype != AF_INET) {
		if(i != num -1)
		    continue;
		else{
            	    log ("unknown address family: %d", hp->h_addrtype);
		    retCode = 1;
		    goto end;
		}
            }
            memset ((char *) &sin, 0, sizeof (sin));
            memcpy ((char *) &sin.sin_addr, hp->h_addr, hp->h_length);
            sin.sin_family = hp->h_addrtype;
            sin.sin_port = htons (mailport);
            if ((s = socket (AF_INET, SOCK_STREAM, 0)) < 0) {
		if(i != num-1)
		    continue;	
		else{
                    log ("socket: %s", strerror (errno));
		    retCode = 2;
		    goto end;
		}
            }
            if (connect (s, (struct sockaddr *) &sin, sizeof (sin)) < 0) {
		if(i != num-1)
		    goto end1;	
		else{
                    log ("connect: %s", strerror (errno));
		    retCode = 3;
		    goto end;
		}
            }
            if ((r = dup (s)) < 0) {
		if( i != num-1)
	            goto end1;	
		else{
                    log ("dup: %s", strerror (errno));
		    retCode = 4;
		    goto end;
		}
            }
            if ((sfp = fdopen (s, "w")) == 0) {
		if( i != num-1)
	  	    goto end1;	
		else{
                    log ("fdopen: %s", strerror (errno));
		    retCode = 5;
		    goto end;
		}
            }
            if ((rfp = fdopen (r, "r")) == 0) {
		if( i != num-1)
     		    goto end1;
		else{		
                    log ("fdopen: %s", strerror (errno));
		    retCode = 6;
		    goto end;
		}
            }
            /* 
             *  Give out SMTP headers.
             */
            ret = get_response1 ();  /* banner */
	    if(ret)
		goto end1;
#ifdef SMTP_AUTH
	    if(conf->smtp_auth)
                ret = chat ("EHLO %s\r\n", my_name);
	    else
                ret = chat ("HELO %s\r\n", my_name);
#else
            ret = chat ("HELO %s\r\n", my_name);
#endif
	    if(ret)
		goto end1;
		
	    if(conf->smtp_auth && chk_ehlo){
            	ret = chat ("AUTH LOGIN \r\n");
	    	if(ret)
		    goto end1;
#ifdef AUTH_TEST
	    	base64Encode(def_smtp_user, enc_user);
#else
	    	base64Encode(conf->auth_user, enc_user);
#endif		
            	ret = chat ("%s\r\n", enc_user);
	    	if(ret)
		    goto end1;
#ifdef AUTH_TEST
	    	base64Encode(def_smtp_pw, enc_pw);
#else
	    	base64Encode(conf->auth_pw, enc_pw);
#endif            	
		ret = chat ("%s\r\n", enc_pw);
	    	if(ret)
		    goto end1;
	    }

	    
            ret = chat ("MAIL FROM: <%s>\r\n", from_addr);
	    if(ret)
		goto end1;
    	    for(i=0;i<to_num	;i++){
		ret = chat("RCPT TO: <%s>\r\n", to_addr[i]);
	    	if(ret)
			break;
	    }
	    if(ret)
		goto end1;
            ret = chat ("DATA\r\n");
	    if(ret)
		goto end1;
	   
	    return 0;		//normal end and must to end with EndSMTP()
end1:
	    if(sfp)
		fclose(sfp);
	    if(rfp)
		fclose(rfp);		   
	    close(s);	    
	    continue;
        }
        if (j == to_num - 1) {
//            log ("%s: unknown host\n", mailhost);
            retCode = 7;
	    goto end;
	}
   }
   
end:
   for(i=0;i<to_num;i++)
	free(to_addr[i]);	
   if(s)
	close(s);
   if(r)
	close(r);
   if(sfp)
	fclose(sfp);
   if(rfp)
	fclose(rfp);
   
   return retCode;
}

int EndSMTP(void)
{
    fprintf(sfp, "\r\n"); //terminate the text to tell MTA the end of message

    /* 
     *  Give out SMTP end.
     */
    
    chat(".\r\n");
    chat("QUIT\r\n");

    /* 
     *  Die gracefully ...
     */
    close(s);
    close(r);
    fclose(sfp);
    fclose(rfp);

    return 0;
}

/*EOF*/
