/***************************************************************
*             Copyright (C) 2003 by SerComm Corp.
*                    All Rights Reserved.
*
*      Use of this software is restricted to the terms and
*      conditions of SerComm's software license agreement.
*
*                        www.sercomm.com
****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include <malloc.h>
#include <time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <pwd.h>
#include <netdb.h>
#include <errno.h>
#include <unistd.h>
#include "smtpc_mime.h"

#define LINE_LIMIT 71

extern CMD_CONF	cmd;

static MT_MSG mt_msg = {
    "", // caller
    0,  // status
    0,	// total number of input files
    NULL,  // from
    NULL,  // to
    NULL,  // error to 	
    NULL,  // subject
    NULL,  // cc
    NULL,  // Bcc
    NULL,  // mfn, output mail file name, filename.eml
    NULL,  // ifn, input file names
    NULL   // input file format
};

static char *boundary="=_kow29Sia40SwsAG";
static char basis_64[] =
   "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

int get_fromaddr(char *buf,int size)
{
    char my_name[128];
//    struct hostent *hp;
//    struct passwd *pwd;

    if (gethostname(my_name, sizeof(my_name) - 1) < 0) {
        printf("gethostname: %s", strerror(errno));
        return(1);
    }
#if 0
    if ((hp = gethostbyname(my_name)) == NULL) {
        printf("%s: unknown host\n", my_name);
        return(1);
    }
    strcpy(my_name, hp->h_name);
    if ((pwd = getpwuid(getuid())) == 0) 
        snprintf(buf,size, "userid-%d@%s", getuid(), my_name);
    else
        snprintf(buf,size, "%s@%s", pwd->pw_name, my_name);
#endif
    return(0);
}
int gethostaddr(char buf[16])
{
    char my_name[128];
//    struct hostent *hp;
//    struct passwd *pwd;
//    struct in_addr *addr;

    if (gethostname(my_name, sizeof(my_name) - 1) < 0) {
        printf("gethostname: %s", strerror(errno));
        return(1);
    }
#if 0
    if ((hp = gethostbyname(my_name)) == NULL) {
        printf("%s: unknown host ya\n", my_name);
        return(1);
    }
    addr=(struct in_addr *)hp->h_addr_list[0];
    strncpy(buf,inet_ntoa(*addr),16);
#endif 
    return(0);
}
static void output64chunk(int c1, int c2, int c3, int pads, FILE *o_file) {
    char equ='=';
    fwrite(&basis_64[c1>>2],1,1, o_file);
    fwrite(&basis_64[((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4)],1,1, o_file);
    if(pads == 2) {
        fwrite(&equ,1,1, o_file);
        fwrite(&equ,1,1, o_file);
    } else if(pads) {
        fwrite(&basis_64[((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6)],1,1, o_file);
        fwrite(&equ,1,1, o_file);
    } else {
        fwrite(&basis_64[((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6)],1,1, o_file);
        fwrite(&basis_64[c3 & 0x3F],1,1, o_file);
    }
}

static void GetCurrentRFC822Date(char * pszBuffer) {
    time_t curtime;
    char *stime;
//    char buf[128];


    // Get the current time.
    time(&curtime);
    localtime(&curtime); 
    stime=ctime(&curtime);
    // Fill out the buffer.
#ifdef UCLIBC_RR
    sprintf(pszBuffer, "%.3s, %.2s %.3s %.4s %.8s",
        &stime[0],
        &stime[8],
        &stime[4],
        &stime[20],
        &stime[11]
        );
#else
    sprintf(pszBuffer, "%.3s, %.2s %.3s %.4s %.8s %s",
        &stime[0],
        &stime[8],
        &stime[4],
        &stime[20],
        &stime[11],
        tzname[0]);
#endif
}

static void GetMessageID(char *pszBuffer)
{
    time_t curtime;
    char *stime;
    BYTE buf[16];
    // Get the current time.
    time(&curtime);
    stime=ctime(&curtime);
    gethostaddr(buf);	
    srand((unsigned)time(NULL));
    sprintf(pszBuffer, "<%.24s.%d@%s>",
        stime,rand(),buf);
}
void output_addrlist(FILE *o_file, char **p)
{
	while (*p) {
                    fprintf(o_file,"<%s>",*p);
                    p++;
                    if (*p)
                        fputs(", ", o_file);
                }  // while (*p)
}	

//Melinda modified start from here !!!

//===============================================================
//NEED_TO_DO: the information in mt_msg should be get from our 
//            configuration file
//===============================================================
static void MF_CreateFileHeader(FILE *o_file) {
	//create MIME64 file header	
//	char **p;
	char buf[128];
//	BYTE ip[4];
    
            char cDate[MAX_DATE_LENGTH];
            char cMID[MAX_MESSAGE_ID_LENGTH];

//	mt_msg.to=malloc(10);		//allow mail to 10 recipients

	mt_msg.from=cmd.from;	
	mt_msg.to=cmd.to;
	mt_msg.subject=cmd.subject;

            if (o_file == NULL)
                return;
            GetCurrentRFC822Date(cDate);
            GetMessageID(cMID);

            // Output the header info.
            fprintf(o_file,"Date: %s\r\n",cDate);
            fputs("From: ", o_file);
            if (mt_msg.from)
                fputs(mt_msg.from, o_file);
            else {
            	if (get_fromaddr(buf,sizeof(buf))== 0) {
            	   fprintf(o_file,"<%s>",buf);
	 	   printf("From address=%s\r\n",buf);
        	} else {
                   gethostaddr(buf);	
            	   fprintf(o_file, "<NetworkScanner@%s>",buf);
            	   printf("From address=NetworkScanner@%s\r\n",buf);
        	}
                
            }
            
            fputs("\r\nTo: ", o_file);
            if (mt_msg.to) {
                fputs(mt_msg.to, o_file);
            }
/*
            if (mt_msg.err_to) {
            	fputs("\nErrors-To: ", o_file);
                p = mt_msg.err_to;
		output_addrlist(o_file,p);
            }
            
            if (mt_msg.cc) {
            	fputs("\nCc: ", o_file);
                p = mt_msg.cc;
		output_addrlist(o_file,p);
            }
            
            if (mt_msg.bcc) {
            	fputs("\nBcc: ", o_file);
                p = mt_msg.bcc;
		output_addrlist(o_file,p);
            }
*/
            fputs("\r\nSubject: ", o_file);
            if (mt_msg.subject)
                fputs(mt_msg.subject, o_file);
            fputs("\r\n", o_file);
            fprintf(o_file,"Message-ID: %s\r\n",cMID);
            fputs("MIME-Version: 1.0\r\n", o_file);
       
//	free(mt_msg.to);
//	free(mt_msg.to[0]);    
}


/*
**  transform to MIME-style quoted printable
**
**  Extracted from the METAMAIL version 2.7 source code (codes.c)
**  and modified to emit \r\n at line boundaries.
*/

static char basis_hex[] = "0123456789ABCDEF";


int qp_ct = 0;
int qp_prevc = 255;
int qp_special=0;
int qp_prev_q[3];
int qp_prev_q_len=0;
int qp_prev_q_idx=0;

//=============================================================
// purpose: get next character
// input: buf - input buffer
//        size - size of buffer
// output: i - buffer index
// return: the next character
// Rule: 1. if there is data in qp_prev_q then return char
//          from that queue
//       2. else return data from buf and add buffer index
//=============================================================
int qp_getc(unsigned char *buf,unsigned int size,unsigned int *i)
{
   int j;
   if(qp_prev_q_len){
        qp_prev_q_len--;
        j=qp_prev_q[qp_prev_q_idx];

        if(qp_prev_q_len)
          qp_prev_q_idx++;
        else{
          qp_prev_q_idx=0;
          memset(qp_prev_q,0,3);
        }

        return(j);
   }
   else{
       if(*i>=size)
          return(EOF);
       j=(int)buf[*i];
       (*i)+=1;
       return(j);
   }

}

//======================================================
// purpose: transfer to pq format and output to outfile
// input: inbuf - input buffer
//        size - size of input buffer
//        first - 1= the first buffer of this file
//        last - the last buffer of this file
//        outfile - output file descriptor
//======================================================
void toqp(unsigned char *inbuf,unsigned int size,int first,int last, FILE *outfile)
{
    int c;
    unsigned int  i=0,j;

    if(first){
        qp_ct=0;
        qp_prevc=255;
        qp_special=0;
        qp_prev_q_len=0;
        qp_prev_q_idx=0;

    }
    if(qp_special){
        qp_special=0;
        goto xxx;
    }
    while ( (c=qp_getc(inbuf,size,&i))!=EOF) {
        if (   (c < 32 && (c != '\n' && c != '\t'))
            || (c == '=')
            || (c >= 127)
            || (qp_ct == 0 && c == '.')               ) {
                putc('=', outfile);
                putc(basis_hex[c >> 4], outfile);
                putc(basis_hex[c & 0xF], outfile);
                qp_ct += 3;
                qp_prevc = 'A'; /* close enough */

        }
        else if (c == '\n') {
          if (qp_prevc == ' ' || qp_prevc == '\t') {
            putc('=', outfile);  /* soft & hard lines */
            putc(c, outfile);
          }
          putc(c, outfile);
          qp_ct = 0;
          qp_prevc = c;
        }
        else { //else 2
          if (c == 'F' && qp_prevc == '\n') {
          /*
           * HORRIBLE but clever hack suggested by MTR for
           * sendmail-avoidance
           */
            //!!! we need to know the next 4 char but it is in next buffer
            if((i+4)>=size && !last){
               qp_special=1;
               qp_prev_q_len=(int)(size-i);
               for(j=0;j<qp_prev_q_len;j++)
                   qp_prev_q[j]=(int)inbuf[i++];
               return;
            }
xxx:
            c=qp_getc(inbuf,size,&i);

            if (c == 'r') {
              c=qp_getc(inbuf,size,&i);
              if (c == 'o') {
                c=qp_getc(inbuf,size,&i);
                if (c == 'm') {
                   c=qp_getc(inbuf,size,&i);
                   if (c == ' ') {
                        /* This is the case we are looking for */
                        fputs("=46rom", outfile);
                        qp_ct += 6;
                   } else {
                        fputs("From", outfile);
                        qp_ct += 4;
                   }
                } else {
                   fputs("Fro", outfile);
                   qp_ct += 3;
                }
              } //if (c=='o')
              else {
                fputs("Fr", outfile);
                qp_ct += 2;
              }
            } //if (c='r')
            else {
               putc('F', outfile);
               ++qp_ct;
            }
            //ungetc(c, infile);
            i--;
            qp_prevc = 'x'; /* close enough -- printable */
          } //if (c == 'F' && qp_prevc == '\n')
          else {
                putc(c, outfile);
                ++qp_ct;
                qp_prevc = c;
          }
        } //else 2
        if (qp_ct > 72) {
                putc('=', outfile);
                putc('\r', outfile);
                putc('\n', outfile);
                qp_ct = 0;
                qp_prevc = '\n';
        }


    }//while

    if (last && qp_ct) {
    putc('=', outfile);
    putc('\r', outfile);
    putc('\n', outfile);
    }
    return;
}
int b64_ct=0;
int b64_q[2];
int b64_q_len=0;
int b64_q_idx=0;

//==============================================================
// purpose: check if we can get next 3 characters in this buffer
//==============================================================
int can_get3char(BYTE *buf,unsigned int size,unsigned int idx,int last)
{
   if(last || (b64_q_len+size-idx)>=3)
      return(1);
   else
      return(0);
}
//======================================================
// purpose: get next 3 characters from buffer
// input: buf - input buffer
//        size - buffer size
//        last - 1 means buffer is the last buffer
// output: c[3] - buffer to save the next 3 characters
//         idx - pointer to next character of buf
//======================================================
void get3char(int c[3],BYTE *buf,unsigned int size,int last,unsigned int *idx)
{
   int i=0;

   while(b64_q_len && i<3){
      c[i]=b64_q[i++];
      b64_q_len--;
   }
   if(b64_q_len==0){
      b64_q_idx=0;
   }
   for(;i<3 && (*idx <size);i++){
      c[i]=(int)buf[*idx];
      (*idx)+=1;
   }
   while (i<3 && last)
      c[i++]=EOF;

}

void write_base64_file(BYTE *buf,unsigned int size,int first, int last, FILE *o_file)
{
    int c[3];
    char *cr="\r\n";
    unsigned int i=0;

    if(first){
       b64_ct=0;
       b64_q_len=0;
       b64_q_idx=0;
    }

    while(can_get3char(buf,size,i,last)) {
        get3char(c,buf,size,last,&i);


            if(c[0]==EOF)
                break;

            if(c[1] == EOF){
                output64chunk(c[0], 0, 0, 2, o_file);
            }
            else {
                if(c[2]  == EOF){
                    output64chunk(c[0], c[1], 0, 1, o_file);
                }
                else {
                    output64chunk(c[0], c[1], c[2], 0, o_file);
                }
                
            }

            b64_ct += 4;
            if(b64_ct > LINE_LIMIT) {
                fwrite(cr,2,1, o_file);
                b64_ct = 0;
            } // if(b64_ct)


    } // while(b64_c1)
    if(!last){ //buffer size is not triple
        while((i<size) && (b64_q_len<2)){
           b64_q[b64_q_idx++]=buf[i++];
           b64_q_len++;
        }
    }
    if(last && b64_ct)
        fwrite(cr,2,1, o_file);


}
//===============================================================
//NEED_TO_DO: If we want to add file name in each file's header
//            the interface should be changed
//===============================================================
//======================================================
// purpose: Encode attachment file
// input: i_fmt - input file format
//        buf - input buffer
//        size - size of input buffer
//        first - 1 means the first buffer of this file
//        last - 1 means the last buffer of this file
//        o_fp - output file descriptor
//        fname - file name of attachment
//======================================================
void MF_EncodeAttachment(int i_fmt, BYTE *buf, unsigned int size, int first, int last, FILE *o_fp,char *fname) {
    char *itype=NULL;

    if(first){

        switch (i_fmt) {
        case FMT_TEXT1: //ISO8859-1
            itype = "text/plain; charset=ISO-8859-1";
            break;
        case FMT_TEXT:
            itype = "text/plain; charset=us-ascii";
            break;
        case FMT_TIFF:
            itype = "image/tiff; name=\"";
            break;
        case FMT_JPEG:
            itype = "image/jpeg; name=\"";
            break;
        case FMT_GIF:
            itype = "image/gif; name=\"";
            break;
        case FMT_MPEG:
            itype = "video/mpeg; name=\"";
            break;
        default: //FMT_TEXT and other format
            itype = "application/octet-stream; name=\"";
        }  // switch (i_format)
     }   
     switch (i_fmt) {
        case FMT_TEXT1: //ISO8859-1
            if(first){ 
               fprintf(o_fp,"Content-Type: %s\r\n",itype);
               fprintf(o_fp,"Content-Transfer-Encoding: quoted-printable\r\n\r\n");
            }
            toqp(buf,size,first,last,o_fp);
            break;
        case FMT_TEXT:  //US-ASCII
            if(first){ 	
               fprintf(o_fp,"Content-Type: %s\r\n",itype);
               fprintf(o_fp,"Content-Transfer-Encoding: 7bit\r\n\r\n");
            }
            fwrite(buf,1,size,o_fp);
            break;
        default:
            if(first){
               fprintf(o_fp,"Content-Type: %s%s\"\r\n",itype,fname);
               fprintf(o_fp,"Content-Transfer-Encoding: base64\r\n");
               fprintf(o_fp,"Content-Disposition: attachment; filename=\"%s\"\r\n\r\n",fname);
            }
            write_base64_file(buf,size,first,last, o_fp);
     }

}

//======================================================
// purpose: Send mail with single file
// input: i_fmt - input file format
//        buf - input buffer
//        size - size of input buffer
//        first - 1 means the first buffer of this file
//        last - 1 means the last buffer of this file
//        o_fp - output file descriptor
//	  fname - file name of attachment
//======================================================
int Tx_OneFile(int i_fmt, BYTE *buf, unsigned int size, int first, int last, FILE *o_fp,char *fname) 
{
   if(first)	
        MF_CreateFileHeader(o_fp);
        
   MF_EncodeAttachment(i_fmt,buf,size,first,last,o_fp,fname);
   //close session with smtp server...
   return 0;
}
//======================================================
// purpose: Send mail with multiple files
// input: i_fmt - input file format
//        buf - input buffer
//        first_f - 1 means first file
//	  last_f - 1 means last file
//        size - size of input buffer
//        first - 1 means the first buffer of this file
//        last - 1 means the last buffer of this file
//        o_fp - output file descriptor
//	  fname - file name of attachment
//======================================================
int Tx_MultiFile(int i_fmt, BYTE *buf,int first_f,int last_f, unsigned int size, int first, int last, FILE *o_fp,char *fname) 
{

   if(first) { 
      if(first_f){ //first buffer of first file
   	MF_CreateFileHeader(o_fp);
	//***** Note: there must have at lease one space before boundry= ****
        fprintf(o_fp,"Content-Type: multipart/mixed;\r\n  boundary=\"%s\"\r\n",boundary);
        fputs("Content-Transfer-Encoding: 7bit\r\n\r\n", o_fp);
        fputs("This is a multi-part message in MIME format.\r\n\r\n", o_fp);
        fprintf(o_fp,"--%s\r\n",boundary);
      } 
      else 
        fprintf(o_fp,"\r\n--%s\r\n",boundary);
    
   }	
   MF_EncodeAttachment(i_fmt,buf,size,first,last,o_fp,fname);
   if(last_f && last) //last buffer of last file
      fprintf(o_fp,"\r\n\r\n--%s--\r\n",boundary);
   return(0);
}
#if 0 
        //for test only
int main (int argc, char *argv) {
    
    char *to[2] = {"johnson@sercomm.com.tw",NULL};
    char *err_to[2] ={"root@172.31.6.58",NULL};
    char *i_f[3] = {"out.txt", "2100.jpg","test.jpg"};
    char subject[]="Test MIMI transfer program";
    char *cc[2]={"melinda_tsao@sercomm.com.tw",NULL};
    char *bcc[2]={"root@172.31.6.58",NULL};
    char mfn[]="test.eml";
    int  i_fmt[3]={FMT_TEXT1,FMT_JPEG,FMT_JPEG};
    MT_MSG msg = {
            
    "test", // caller
    0,  // status
    1,	// total number of input files
    //2,	// total number of input files
    NULL,  // from
    to,  // to
    err_to,  // error to 	
    subject,  // subject
    cc,  // cc
    bcc,  // Bcc
    mfn,  // mfn, output mail file name, filename.eml
    i_f,  // ifn, input file names
    i_fmt // input file formats
    };
    BYTE buf[121];
    FILE *inf,*outf;
    size_t len;
    int first,last;
    int i,first_f,last_f;
    int j;

    memcpy(&mt_msg,&msg,sizeof(MT_MSG));
    outf=fopen("out.eml","w");
    if(!outf){
	printf("Can't open out.eml\n");
	return(0);
    }
  for(i=0;i<3;i++){
    inf=fopen(i_f[i],"r");
    if(!inf){
	printf("Can't open file %s\n",i_f[i]);
	return(0);
    }
    if(i==0)
	first_f=1;
    else
	first_f=0;
    if(i==2)
	last_f=1;
    else
	last_f=0;
    first=1;last=0; 
    j=0;
    while ((len=fread(buf,1,sizeof(buf),inf))){
       if(len<sizeof(buf))
          last=1;
       Tx_MultiFile(i_fmt[i],buf,first_f,last_f,len,first,last,outf,mt_msg.ifn[i]); 
       if(first)
          first=0;
       if(last) 
          break;
       j++;
    }
    fclose(inf);
  }
  fclose(outf);
  return 0;
}
#endif

