/* make a file with holes */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

char buf[2048];

#define htonl(x) (x)

int
main(int argc, char *argv[])
{
//  int block=0;
  int count=0;
  int pos=0;
  int zcount=0;
  int b;
  int len;
  int in = open(argv[1], O_RDONLY);

  char ch = 0;

  // A second argument can be specified dictating the default char to ignore.
  // If this is not present assume ZERO. (ZRLE)
  if (argc > 2)
	{
	  ch = atoi(argv[2]);
	  fprintf(stderr,"Specified 2nd Argument %c %02X\n",ch,ch);
	}  

  // Find End of File. Report Size.
  len = lseek(in, 0, SEEK_END);
  fprintf(stderr,"Length of original file %d\n",len);
  len = htonl(len);
  write(1, &len, 4); // Write Length of File

  // Reset to Start of File.
  lseek(in, 0, SEEK_SET);


  while(read(in, &buf[count], 1) > 0) 
   {
    pos++; // Current Position

    if (count || (buf[count] != ch)) {
	  if (buf[count] == ch)   // Vadim
		zcount++;
	  count ++;

    // Expand has a maximum buffer size of 2048 bytes, we want to
    // keep blocks >= 8 bytes for effiency.
    if ((zcount == 8) || (count == 2048)) 
          {
//           fprintf(stderr," Writing Block %d Start Address %04X Length %d\n",block++,pos-count,count-1);

	   // Write Starting Position
	   b = htonl(pos-count);
	   write(1,&b,4);

	   // Write Length of Block
           b = htonl(count-1);
   	   write(1,&b,4);

	   // Write Block 
     	   write(1,buf,count-1);
	   
           // Reset counters
           count = zcount = 0;
	  }
	}
  }

  if (count) {
    b = htonl(pos-count);
    write(1,&b,4);
    b = htonl(count);
    write(1,&b,4);
    write(1,buf,count);
  }
  return 0;
}
