/*****************************************************************************
  segment-dsc21.c:
          Special memcpy routines to accomodate copying to/from DSP ram across
          the bridge.
  copyright:
          (C) 2001 RidgeRun, Inc. (http://www.ridgerun.com)
  author: Gordon McNutt <gmcnutt@ridgerun.com>
 
 *****************************************************************************/

#include <asm/arch/dspi.h>

extern void fast_memcpy(void *to, const void *from, int count);

void memcpy(void *to, const void *from, int count)
{
   if (dspi_in_arm(from)) {
      dspi_memcpy_from_dsp(to, from, count);
   } else if (dspi_in_arm(to)) {
      dspi_memcpy_to_dsp(to, from, count);          
   } else {
      fast_memcpy(to, from, count);
   }
}

void memcpy_tofs(void *x, void *y, int z) { memcpy(x, y, z); }
void memcpy_fromfs(void *x, void *y, int z) { memcpy(x, y, z); }
void * memmove(void *x, const void *y, __kernel_size_t z)
{ 
        memcpy(x, y, z); 
        return x; /* Revisit: what should we really return? */
}
void __memcpy_fromfs(void *x, void *y, int z) { memcpy(x, y, z); }
void __memcpy_tofs(void *x, void *y, int z) { memcpy(x, y, z); }
void _memcpy(void *x, void *y, int z) { memcpy(x, y, z); }
