/*
 
  burstc_ioctl.h
 
  This file represents the Burst Compress DSC21 peripheral.  

  Copyright (C) 2001, RidgeRun, Inc.
 
*/ 
#ifndef __BURSTC_IOCTL_H__
#define __BURSTC_IOCTL_H__
 
#include <asm/ioctl.h>
 
/* List of ioctl commands. */
 
#define BURSTC_MAGIC_NUMBER 'b'
 

typedef struct {
     __u32 storeAddr;       // SDRAM buffer to decompress into
     __u16 pictureID;       // picture ID to be decompressed (starting from 0)
     __u16 noBlock;         // blocking (0 = blocking)
} burstc_decompress_t;
#define BURSTC_DECOMPRESS       _IOW(BURSTC_MAGIC_NUMBER, 0, sizeof(burstc_decompress_t))

#define BURSTC_COMPRESS         _IO(BURSTC_MAGIC_NUMBER, 1)

typedef struct {
     __u32 startAddr;       // start/stop map the SDRAM buffer to B/C into
     __u32 stopAddr;
     __u16 numberOfPic;     // number of pictures to be captured
     __u8 captureInterval;  // capture interval     
} burstc_compress_setup_t;
#define BURSTC_COMPRESS_SETUP   _IOW(BURSTC_MAGIC_NUMBER, 2, sizeof(burstc_compress_setup_t))

#if defined(CONFIG_ARCH_DSC21)
#define BURSTC_STATUS           _IO(BURSTC_MAGIC_NUMBER, 3)
#define BURSTC_IOC_MAXNR 4
#elif defined(CONFIG_ARCH_DSC24)
#define BURSTC_STATUS_COMP           _IO(BURSTC_MAGIC_NUMBER, 3)
#define BURSTC_STATUS_DECOMP         _IO(BURSTC_MAGIC_NUMBER, 4)
#define BURSTC_IOC_MAXNR 5
#endif
 
/* Major numbers, (from Documentation/devices.txt local/experimental list)  */
 
#define BURSTC_MAJOR     123
 
#endif            // __BURSTC_IOCTL_H__
