/*
 * asm/arch/dscfb.h
 *
 * BRIEF MODULE DESCRIPTION
 *
 *        The DSC21 framebuffer driver header
 *
 * REFERENCES
 *
 *        TMS320DSC21 Register Manual
 *        DSC Phase 2 ARM Peripherals User Manual
 *
 * Copyright (C) 2001 RidgeRun, Inc. (http://www.ridgerun.com)
 * Author: Alex McMains <aam@ridgerun.com>
 *
 */

/* Defines */
#define FBIOPUT_POS (FBIOPAN_DISPLAY + 1)
#define FBIOGET_POS (FBIOPUT_POS + 1)
#define FBIOPUT_MODE (FBIOGET_POS + 1)
#define FBIOGET_MODE (FBIOPUT_MODE + 1)
#define FBIOPUT_BKGRD (FBIOGET_MODE + 1)
#define FBIOGET_BKGRD (FBIOPUT_BKGRD + 1)
#ifdef CONFIG_ARCH_DSC21 
#define FBIOPUT_OSDSTATE (FBIOGET_BKGRD + 1)
#define FBIOGET_OSDSTATE (FBIOPUT_OSDSTATE + 1)
#endif

/* Typedefs */
typedef enum {FALSE, TRUE} BOOL;
typedef unsigned short USHORT;
typedef unsigned char UCHAR;
typedef unsigned long ULONG;
typedef unsigned int UINT;
enum {OSD1BIT, OSD2BIT, OSD4BIT, OSD8BIT, OSDYUV};


// starting x and y coords for win1 and win2
struct dscfb_pos
{
	UINT xpos;
	UINT ypos;
};

// register settings for mode
struct dscfb_mode
{
        BOOL clut_addr;
        UINT bpp;
        BOOL trans;
	UINT blend;
	BOOL active;
#ifdef CONFIG_ARCH_DSC24
  	UINT vzoom;
	UINT hzoom;
#endif 
};

/* Local LCD controller parameters */
struct dscfb_par 
{
  UCHAR modename[40];
  ULONG	smem_start;
  ULONG smem_len;	
  ULONG	xp0;
  ULONG	yp0;
  ULONG	xp1;
  ULONG	yp1;
  ULONG	mode;
};
