/*
 *  
 *    venc.h
 *     
 *    This file represents the DSC24 video encoder. 
 *
 *    Copyright (C) 2001, RidgeRun, Inc.
 *          
*/

#ifndef __I2C_H__
#define __I2C_H__
 
#include <asm/ioctl.h>
 
/* List of ioctl commands. */
 
#define I2C_MAGIC_NUMBER 'i'

#define I2C_START _IO(I2C_MAGIC_NUMBER, 0)
 
#define I2C_STOP _IO(I2C_MAGIC_NUMBER, 1)

#define I2C_GET_ACK _IO(I2C_MAGIC_NUMBER, 2)

#define I2C_TRANSFER _IO(I2C_MAGIC_NUMBER, 3)

#define I2C_SEND_NACK _IO(I2C_MAGIC_NUMBER, 4)

#define I2C_RECEIVE _IO(I2C_MAGIC_NUMBER, 5)

#define SET_SLAVE_ADDR _IO(I2C_MAGIC_NUMBER, 6)

#define SET_SUB_ADDR _IO(I2C_MAGIC_NUMBER, 7)
 
#define I2C_IOC_MAXNR 7
 
/* Major numbers, (from Documentation/devices.txt local/experimental list)  */
 
#define I2C_MAJOR     127


#endif            // __I2C_H__
