/*
 * File: irq.h
 *
 * Note: Derived with help from include/asm-arm/arch-trio/irq.h
 *
 * Copyright:
 *         (C) 2001 RidgeRun, Inc. (http://www.ridgerun.com)
 *
 * Author: Steve Johnson <stevej@ridgerun.com>
 *
 * Modifications:
 *    -- Oct 2001, Extended for Orion EVM
 *       Steve Kranz <skranz@ridgerun.com>
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 *
 * THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 * WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 * NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 * USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * You should have received a copy of the  GNU General Public License along
 * with this program; if not, write  to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#define BUILD_IRQ(s,n,m)

struct pt_regs;

extern int IRQ_interrupt(int irq, struct pt_regs *regs);
extern int timer_IRQ_interrupt(int irq, struct pt_regs *regs);
extern int fast_IRQ_interrupt(int irq, struct pt_regs *regs);
extern int bad_IRQ_interrupt(int irq, struct pt_regs *regs);
extern int probe_IRQ_interrupt(int irq, struct pt_regs *regs);

#define IRQ_interrupt0  timer_IRQ_interrupt
#define IRQ_interrupt1  IRQ_interrupt
#define IRQ_interrupt2  IRQ_interrupt
#define IRQ_interrupt3  IRQ_interrupt
#define IRQ_interrupt4  IRQ_interrupt
#define IRQ_interrupt5  IRQ_interrupt
#define IRQ_interrupt4  IRQ_interrupt
#define IRQ_interrupt6  IRQ_interrupt
#define IRQ_interrupt7  IRQ_interrupt
#define IRQ_interrupt8  IRQ_interrupt
#define IRQ_interrupt9  IRQ_interrupt
#define IRQ_interrupt10 IRQ_interrupt
#define IRQ_interrupt11 IRQ_interrupt
#define IRQ_interrupt12 IRQ_interrupt
#define IRQ_interrupt13 IRQ_interrupt
#define IRQ_interrupt14 IRQ_interrupt
#define IRQ_interrupt15 IRQ_interrupt
#define IRQ_interrupt16 IRQ_interrupt
#define IRQ_interrupt17 IRQ_interrupt
#define IRQ_interrupt18 IRQ_interrupt
#define IRQ_interrupt19 IRQ_interrupt
#define IRQ_interrupt20 IRQ_interrupt
#define IRQ_interrupt21 IRQ_interrupt
#define IRQ_interrupt22 IRQ_interrupt
#define IRQ_interrupt23 IRQ_interrupt
#define IRQ_interrupt24 IRQ_interrupt
#define IRQ_interrupt25 IRQ_interrupt
#define IRQ_interrupt26 IRQ_interrupt
#define IRQ_interrupt27 IRQ_interrupt
#define IRQ_interrupt28 IRQ_interrupt
#define IRQ_interrupt29 IRQ_interrupt
#define IRQ_interrupt30 IRQ_interrupt
#define IRQ_interrupt31 IRQ_interrupt

#define IRQ_INTERRUPT(n)   (void (*)(void))IRQ_interrupt##n
#define FAST_INTERRUPT(n)  (void (*)(void))fast_IRQ_interrupt
#define BAD_INTERRUPT(n)   (void (*)(void))bad_IRQ_interrupt
#define PROBE_INTERRUPT(n) (void (*)(void))probe_IRQ_interrupt

static __inline__ void irq_init_irq(void)
{
  extern void init_irq(void);
  init_irq();
}

#ifdef CONFIG_ARCH_ORION
static unsigned long const irq_to_mask[] = {
  0x00000001, /* 0  - Timer 0            */
  0x00000002, /* 1  - Timer 1            */
  0x00000004, /* 2  - Timer 2            */
  0x00000008, /* 3  - GPIO0              */
  0x00000010, /* 4  - Ethernet           */
  0x00000020, /* 5  - KBGPIO[7:0]        */
  0x00000040, /* 6  - Uart (serial port) */
  0x00000080, /* 7  - uart (IRDA)        */
  0x00000100, /* 8  - KBGPIO[15:8]       */
  0x00000200, /* 9  - GPIO3              */
  0x00000400, /* 10 - GPIO2              */
  0x00000800, /* 11 - I2C                */
  0x00001000, /* 12 - GPIO1              */
  0x00002000, /* 13 - SPI                */
  0x00004000, /* 14 - GPIO[19:4]         */
  0x00008000  /* 15 - API                */
};
static __inline__ void mask_irq(unsigned int irq)
{
  *((volatile unsigned long *)MASK_IT_REG) |= irq_to_mask[irq];
}
static __inline__ void unmask_irq(unsigned int irq)
{
  *((volatile unsigned long *)MASK_IT_REG) &= ~irq_to_mask[irq];
}
static __inline__ unsigned long get_enabled_irqs(void)
{
  return ((~(*((volatile unsigned long *)MASK_IT_REG)))&0x0000ffff);  
}
#endif /* CONFIG_ARCH_ORION */

#if defined(CONFIG_ARCH_DSC2X)
#if defined(CONFIG_ARCH_DSC21)
static u16 const irq_to_mask[] = {
        0x0001, /* 0 - Timer 0 */
        0x0002, /* 1 - Timer 1 */
        0x0004, /* 2 - Timer 2 */
        0x0008, /* 3 - Timer 3 */
        0x0010, /* 4 - CCD VD 0 */
        0x0020, /* 5 - CCD VD 1 */
        0x0040, /* 6 - CCD VD 2 */
        0x0200, /* 7 - ENC VD */
        0x0080, /* Serial I/F 0 */
        0x0100, /* Serial I/F 1 */
        0x0400, /* DSP (HPIB) */
        0x0800, /* UART 0 */
        0x1000, /* UART 1 */
        0x2000, /* USB */
        0x4000, /* BURSTC END */
        0x8000, /* External Bus Controller */
        0x0001, /* External Interruption 0 */
        0x0002, /* External Interruption 1 */
        0x0004, /* External Interruption 2 */
        0x0008, /* External Interruption 3 */
        0x0010, /* External Interruption 4 */
        0x0020, /* External Interruption 5 */
        0x0040, /* External Interruption 6 */
        0x0080, /* External Interruption 7 */
        0x0100, /* External DMA I/F */
        0x0200, /* Flash ready */
        0x0400, /* IrDA receive */
        0x0800  /* IrDA transmit */
};
#elif defined(CONFIG_ARCH_DSC24)
static u16 const irq_to_mask[] = {
        0x0001, /* 0 - Timer 0 */
        0x0002, /* 1 - Timer 1 */
        0x0004, /* 2 - Timer 2 */
        0x0008, /* 3 - Timer 3 */
        0x0010, /* 4 - CCD VD 0 */
        0x0020, /* 5 - CCD VD 1 */
        0x0040, /* 6 - CCD VD 2 */
        0x0080, /* 7 - OSD */
        0x0100, /* 8 - Serial I/F 0 */
        0x0200, /* 9 - Serial I/F 1 */
        0x0400, /* 10 - Serial I/F 2 */
        0x0800, /* 11 - DSP HINT */
        0x1000, /* 12 - UART 0 */
        0x2000, /* 13 - UART 1 */
        0x4000, /* 14 - USB */
        0x8000, /* 15 - BURSTC 0 */
        0x0001, /* 16 - BURSTC 1 */
        0x0002, /* 17 - External memory I/F 0 */
        0x0004, /* 18 - External memory I/F 1 */
        0x0008, /* 19 - External Interruption 0 */
        0x0010, /* 20 - External Interruption 1 */
        0x0020, /* 21 - External Interruption 2 */
        0x0040, /* 22 - External Interruption 3 */
        0x0080, /* 23 - External Interruption 4 */
        0x0100, /* 24 - External Interruption 5 */
        0x0200, /* 25 - External Interruption 6 */
        0x0400, /* 26 - External Interruption 7 */
};
#endif
static __inline__ void mask_irq(unsigned int irq)
{
    u32 reg;
    reg = (irq > 15) ? DSC21_IRQ0_ENABLE : DSC21_IRQ1_ENABLE;
    *((u16*)reg) &= ~irq_to_mask[irq];
}
static __inline__ void unmask_irq(unsigned int irq)
{
    u32 reg;
    reg = (irq > 15) ? DSC21_IRQ0_ENABLE : DSC21_IRQ1_ENABLE;
    *((u16*)reg) |= irq_to_mask[irq];
}
static __inline__ unsigned long get_enabled_irqs(void)
{
    unsigned long mask;
    mask = *((u16*)DSC21_IRQ0_ENABLE) || (*((u16*)DSC21_IRQ1_ENABLE) << 16);
    return mask;
}
#endif /* CONFIG_ARCH_DSC2X */
