/*
 *  
 *    vif_ioctl.h
 *     
 *    This file represents the DSC24 video encoder. 
 *
 *    Copyright (C) 2001, RidgeRun, Inc.
 *          
*/

#ifndef __VIF_H__
#define __VIF_H__
 
#include <asm/ioctl.h>

/* List of ioctl commands. */
 
#define VIF_MAGIC_NUMBER 'v'

#define VIF_SET_SYNCEN _IO(VIF_MAGIC_NUMBER, 0)
#define VIF_GET_SYNCEN _IO(VIF_MAGIC_NUMBER, 1)
#define VIF_SET_MODESET _IO(VIF_MAGIC_NUMBER, 2)
#define VIF_GET_MODESET _IO(VIF_MAGIC_NUMBER, 3) 
#define VIF_SET_CLAMP _IO(VIF_MAGIC_NUMBER, 4)
#define VIF_GET_CLAMP _IO(VIF_MAGIC_NUMBER, 5)
#define VIF_SET_HDVDW _IO(VIF_MAGIC_NUMBER, 6)
#define VIF_GET_HDVDW _IO(VIF_MAGIC_NUMBER, 7)
#define VIF_SET_PPLN _IO(VIF_MAGIC_NUMBER, 8)
#define VIF_GET_PPLN _IO(VIF_MAGIC_NUMBER, 9)
#define VIF_SET_LPFR _IO(VIF_MAGIC_NUMBER, 10)
#define VIF_GET_LPFR _IO(VIF_MAGIC_NUMBER, 11)
#define VIF_SET_SPH _IO(VIF_MAGIC_NUMBER, 12)
#define VIF_GET_SPH _IO(VIF_MAGIC_NUMBER, 13)
#define VIF_SET_LNH _IO(VIF_MAGIC_NUMBER, 14)
#define VIF_GET_LNH _IO(VIF_MAGIC_NUMBER, 15)
#define VIF_SET_SLV _IO(VIF_MAGIC_NUMBER, 16)
#define VIF_GET_SLV _IO(VIF_MAGIC_NUMBER, 17)
#define VIF_SET_LNV _IO(VIF_MAGIC_NUMBER, 18)
#define VIF_GET_LNV _IO(VIF_MAGIC_NUMBER, 19)
#define VIF_SET_DECIM _IO(VIF_MAGIC_NUMBER, 20)
#define VIF_GET_DECIM _IO(VIF_MAGIC_NUMBER, 21)
#define VIF_SET_HSIZE _IO(VIF_MAGIC_NUMBER, 22)
#define VIF_GET_HSIZE _IO(VIF_MAGIC_NUMBER, 23)
#define VIF_SET_CCDCAD1 _IO(VIF_MAGIC_NUMBER, 24)
#define VIF_GET_CCDCAD1 _IO(VIF_MAGIC_NUMBER, 25)
#define VIF_SET_CCDCAD2 _IO(VIF_MAGIC_NUMBER, 26)
#define VIF_GET_CCDCAD2 _IO(VIF_MAGIC_NUMBER, 27)
#define VIF_SET_VDINT0 _IO(VIF_MAGIC_NUMBER, 28)
#define VIF_GET_VDINT0 _IO(VIF_MAGIC_NUMBER, 29)
#define VIF_SET_VDINT1 _IO(VIF_MAGIC_NUMBER, 30)
#define VIF_GET_VDINT1 _IO(VIF_MAGIC_NUMBER, 31)
#define VIF_SET_OSDHPOS _IO(VIF_MAGIC_NUMBER, 32)
#define VIF_GET_OSDHPOS _IO(VIF_MAGIC_NUMBER, 33)
#define VIF_SET_OSDVPOS _IO(VIF_MAGIC_NUMBER, 34)
#define VIF_GET_OSDVPOS _IO(VIF_MAGIC_NUMBER, 35)
#define VIF_SET_FIDMODE _IO(VIF_MAGIC_NUMBER, 36)
#define VIF_GET_FIDMODE _IO(VIF_MAGIC_NUMBER, 37)
#define VIF_SET_MEGABLOCK _IO(VIF_MAGIC_NUMBER, 38)
#define VIF_GET_MEGABLOCK _IO(VIF_MAGIC_NUMBER, 39)
#define VIF_SET_MEGAENA _IO(VIF_MAGIC_NUMBER, 40)
#define VIF_GET_MEGAENA _IO(VIF_MAGIC_NUMBER, 41)

#define VIF_IOC_MAXNR 41

/* Major numbers, (from Documentation/devices.txt local/experimental list)  */
 
#define VIF_MAJOR     128

// SYNCEN
#define FSTAT_ODD      0x00
#define FSTAT_EVEN     0x80
#define RDWE_DISABLED  0x00
#define RDWE_ENABLED   0x02
#define VHDEN_DISABLED 0x00
#define VHDEN_ENABLED  0x01

// MODESET
#define DVF_NORMAL         0x00
#define DVF_MODE2          0x8000
#define YCIO_INPUT         0x00
#define YCIO_OUTPUT        0x4000
#define IDS_PORT1          0x00
#define IDS_PORT2          0x2000
#define DWDS_SDRAM         0x00
#define DWDS_EXTERNAL      0x1000
#define ULSEL_74           0x00
#define ULSEL_30           0x800
#define CBCR_CBCR          0x00
#define CBCR_CRCB          0x400
#define DFMT_YUV16         0x00
#define DFMT_YUV12         0x100
#define DFMT_YUV8          0x200
#define DFMT_CCD10         0x300
#define ALAW_OFF           0x00
#define ALAW_ON            0x80
#define FMODE_NONINTERLACE 0x00
#define FMODE_INTERLACE    0x40
#define DPOL_NOCHANGE      0x00
#define DPOL_MSBINVERT     0x20
#define ETRG_RISING        0x00
#define ETRG_FALLING       0x10
#define FIP_POSITIVE       0x00
#define FIP_NEGATIVE       0x08
#define HDP_POSITIVE       0x00
#define HDP_NEGATIVE       0x04
#define VDP_POSITIVE       0x00
#define VDP_NEGATIVE       0x02
#define VHDD_INPUT         0x00
#define VHDD_OUTPUT        0x01

// CLAMP
#define OBL_8     0x00
#define OBL_16    0x2000
#define OBEN_ON   0x00
#define OBEN_OFF  0x1000

// DECIM
#define TPF_OFF  0x00
#define TPF_ON   0x10
#define VDECI_11 0x00
#define VDECI_12 0x04
#define VDECI_14 0x08
#define VDECI_18 0x1a
#define HDECI_11 0x00
#define HDECI_12 0x01
#define HDECI_14 0x02
#define HDECI_18 0x03

// FIDMODE
#define HVP_REVERSE  0x08
#define FIDL_OSDVPOS 0x00
#define FIDL_FID     0x04
#define FIDD_3H      0x02
#define FIDP_REVERSE 0x01

// MEGABLOCK
#define SM_WRITE 0x00
#define SM_LOAD  0x1000

// MEGAENA
#define INTS_VDINT2 0x100
#define MSTAT_SIG   0x02
#define MPX_LOAD    0x01

#endif
