#ifndef _VIDEO_BUFFER_H_
#define _VIDEO_BUFFER_H_
#include <asm/arch/hardware.h>	/* IMG_DATA_SIZE, IMG_FRAME_NUM... */

/*****************************************************************/
/*                                                               */
/*****************************************************************/
typedef struct S_VIDEO {
	unsigned short ResW;	/* Resolution: Width  (640, 320, 160) */
	unsigned short ResH;	/*             Height (480, 240, 120) */
	unsigned short FPS;	/* Frame Rate: Frame/Second */
	unsigned short BitRate;	/* Bit Rate: 640x480=500K, 320x240=300K */
				/*           160x120=200K  ??? */
	unsigned short Quality;/* Video Quality: (Low) Normal (High) ??? */
	unsigned short reserve;	/* reserve: align 4Byte */
	unsigned long  Time;	/* Time Stamp */
} VIDEO __attribute__((packed));

/* -- Padding: PrevEng (CCDC, OSD...) Address MUST be 32 Byte margine!! -- */
/* ----  Or the memoryt address may be wrong and overlay your data!!  ---- */
#define IMG_PAD_SIZE (32 - (sizeof(struct S_FRAME*) + sizeof(struct S_VIDEO) + sizeof(int)))

typedef struct S_FRAME {
	struct S_FRAME *pNext;          // Point to the next frame, 
					// NULL if it's the last frame.
	struct S_VIDEO video;		// Video information
	char   padding[IMG_PAD_SIZE];	// Padding: Make bData[0] align 32Byte 
	int    length;                  // Bytes of image data
	char   bData[IMG_DATA_SIZE];    // Image data
} FRAME __attribute__((packed));
typedef FRAME* PFRAME;

#define IMG_FRAME_SIZE  sizeof(FRAME)
#define IMG_BUF_SIZE    IMG_FRAME_NUM * IMG_FRAME_SIZE

typedef struct S_BUF {
	FRAME *pStart;                   // Point to the first frame
	FRAME *pEnd;                     // Point to the last frame
	int    nTotal;                   // Total frames in buffer
} BUF __attribute__((packed));
typedef BUF * PBUF;

				/* ---- For System-Call Style ---- */
int    sys_InitBuf(void);
PFRAME sys_GetFreeFrame(void);
int    sys_PutFreeFrame(PFRAME pFrame);
PFRAME sys_GetRawFrame(void);
int    sys_PutRawFrame(FRAME *pFrame);
				/* ---- End System-Call Style ---- */

				/* ---- For Video DSP Private Module ---- */
#define IMG_BUF_END            IMG_BUF_START + (IMG_BUF_SIZE)
#define VIDEO_DSP_PRIVATE_BASE IMG_BUF_END + 32	/* For SAVE reason */
				/* ---- End Video DSP Private Module ---- */

#endif /* _VIDEO_BUFFER_H_ */
