#ifndef _SETUP_DSC21_GIO_
#define _SETUP_DSC21_GIO_

#ifdef CONFIG_ARCH_DSC21
typedef enum {
	bit31_16,
	bit15_0
} GIORegSelect;

/*--------------------------------------------------------------------------*/
/* GIO Functions:                                                           */
/*--------------------------------------------------------------------------*/
#define GIO_BIT_0	0	/* Input:        EXT-INT0: Wireless LAN */
#define GIO_BIT_1	1	/* Input:        EXT-INT1: LAN */
#define GIO_BIT_2	2	/* Input:        EXT-INT2: RTC */
#define GIO_BIT_3	3	/* Input:        EXT-INT3: Reset Button */
#define GIO_BIT_5	5	/* Output:       AIC23 SPI:CS_           */
#define GIO_BIT_6	6	/* Output:       AIC23 SPI:SCLK, I2C:SCL */
#define GIO_BIT_7	7	/* Output:       AIC23 SPI:SDI , I2C:SDA */
#define GIO_BIT_8	8	/* Output:       CMOS SCL */
#define GIO_BIT_9	9	/* Bi-direction: CMOS SDA */
#define GIO_BIT_10	10	/* Output:       CMOS CSB */
#define GIO_BIT_11	11	/* Output:       MEM/IO    SEL */
#define GIO_BIT_12	12	/* Output:       RF Vendor SEL */
#define GIO_BIT_13	13	/* Output:       RF        REG */
#define GIO_BIT_14	14	/* Output:       PROT OUT */
#define GIO_BIT_16	0	/* Input:        PROT IN     (BIT16+0 = 16) */
#define GIO_BIT_17	1	/* Input:        CFD1        (BIT16+1 = 17) */
#define GIO_BIT_18	2	/* Input:        CFD2        (BIT16+2 = 18) */
#define GIO_BIT_19	3	/* Input:        PB INPUT    (BIT16+3 = 19) */
#define GIO_BIT_20	4	/* Input:        DIP SW0     (BIT16+4 = 20) */
#define GIO_BIT_21	5	/* Input:        DIP SW1     (BIT16+5 = 21) */
#define GIO_BIT_22	6	/* Input:        DIP SW2     (BIT16+6 = 22) */
#define GIO_BIT_23	7	/* Output:       Reset HW    (BIT16+7 = 23) */
#define GIO_BIT_24	8	/* Output:       Reset RF    (BIT16+8 = 24) */
#define GIO_BIT_25	9	/* Output:       Reset LAN   (BIT16+9 = 25) */
#define GIO_BIT_26	10	/* Output:       Reset Audio (BIT16+10 = 26) */
#define GIO_BIT_27	11	/* Output:       RTC SCL     (BIT16+11 = 27) */
#define GIO_BIT_28	12	/* Bi-direction: RTC SDA     (BIT16+12 = 28) */
#define GIO_BIT_29	13	/* Output:       WLAN LED    (BIT16+13 = 29) */
#define GIO_BIT_30	14	/* Output:       Active LED  (BIT16+14 = 30) */
#define GIO_BIT_31	15	/* Output:       Power LED   (BIT16+15 = 31) */

unsigned short GIOGetDir(GIORegSelect word);
void GIOSetDir(GIORegSelect word, unsigned short value);
unsigned short GIOGetInv(GIORegSelect word);
void GIOSetInv(GIORegSelect word, unsigned short value);
unsigned short GIOGetPortBitSet(GIORegSelect word);
void GIOSetPortBitSet(GIORegSelect word, unsigned short value);
unsigned short GIOGetPortBitClear(GIORegSelect word);
void GIOSetPortBitClear(GIORegSelect word, unsigned short value);
unsigned short GIOGetPortExternalIRQ(void);
void GIOSetPortExternalIRQ(unsigned short irqval);
unsigned short GIOGetMisc(void);
void GIOSetMisc(unsigned short miscval);
/*--------------------------------------------------------------------------*/
/* INT Functions:                                                           */
/*--------------------------------------------------------------------------*/
#define INT_BIT_0	0	 /* External Interrupt 0 */
#define INT_BIT_1	1	 /* External Interrupt 1 */
#define INT_BIT_2	2	 /* External Interrupt 2 */
#define INT_BIT_3	3	 /* External Interrupt 3 */

unsigned short INTGetREG0(void);
unsigned short INTGetREG1(void);
void INTSetREG0(unsigned short value);
void INTSetREG1(unsigned short value);
unsigned short INTGetIQR0(void);
unsigned short INTGetIQR1(void);
void INTSetIQR0(unsigned short value);
void INTSetIQR1(unsigned short value);
/*--------------------------------------------------------------------------*/
/* BUS Functions:                                                           */
/*--------------------------------------------------------------------------*/
#define BUS_BIT_0	0	/* CFC mapping mode: Memory map/IO map */

unsigned short BUSGetBusMD(void);
void BUSSetBusMD(unsigned short value);
#endif /* CONFIG_ARCH_DSC21 */

/* ######## Network Camera H/W Specific Stuff (Start) ######## */
/*--------------------------------------------------------------------------*/
/* MACADDR Functions:                                                       */
/*--------------------------------------------------------------------------*/
int  NC7XXGetMACAddr(unsigned char *addr);
void NC7XXSetMACAddr(unsigned char *value);
/* ######## Network Camera H/W Specific Stuff (End  ) ######## */

#endif /* SETUP_DSC21_GIO_ */
