#ifndef _VIDEO_DSP_PRIVATE_H_
#define _VIDEO_DSP_PRIVATE_H_
#include <linux/buffer.h>

typedef struct V_DSP {
	unsigned long visr;	/* 1: DSP(HPIB) interrupt, 0: No Interrupt */
} V_DSP_t;

V_DSP_t *dsp_private = (V_DSP_t *)VIDEO_DSP_PRIVATE_BASE;

/*
 * Because both the Kernel-Space and User-Space will call these function.
 * We can't Mask/UnMask Interrupt in this header file. The caller must do it
 * by itself.
 */
void VDSPSetISR(unsigned long value)
{
	dsp_private->visr= value; /* 1: DSP has interrupt, 0: No interrupt */
}

unsigned long VDSPGetISR(void)
{
	return (dsp_private->visr); /* 1: DSP has interrupt, 0: No interrupt */
}

#endif /* _VIDEO_DSP_PRIVATE_H_ */
